/* s3.c */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<arpa/inet.h>
#include<fcntl.h>
#include<sys/types.h>
#include<sys/socket.h>

#define BUFSIZE 1000000 
#define FILENAMESIZE 14

int put_file_to_client  (char *file_name); 
int get_file_from_client(char *file_name);

void error_handling(char *message);

int clnt_sd;

int main(int argc, char **argv)
{

	struct sockaddr_in serv_addr;
	struct sockaddr_in clnt_addr;
	int clnt_addr_size;

	int serv_sd;
	int snd_buf = 1000000;
	int rcv_buf = 1000000;
	
	FILE * fp; // pointer of list file
	int i, k, len, select_file;

	char file_name[256];
	char cast_name[256];
	char orig_name[256];
	char list_file_name[256];
	char only_file_name[FILENAMESIZE];
	char message_from_client[4];

	memset(file_name,           0, 256);
	memset(cast_name,           0, 256);
	memset(orig_name,           0, 256);
	memset(list_file_name,      0, 256);
	memset(only_file_name,      0,  14);
	memset(message_from_client, 0,   4);

	if(argc!=2) {
		printf("Usage : %s <port> \n", argv[0]);
		exit(1);
	}

	serv_sd = socket(PF_INET, SOCK_STREAM, 0);

	setsockopt(serv_sd, SOL_SOCKET, SO_SNDBUF, &snd_buf, sizeof(snd_buf));
	setsockopt(serv_sd, SOL_SOCKET, SO_RCVBUF, &rcv_buf, sizeof(rcv_buf));

	if(serv_sd == -1)
		error_handling("socket() error");

	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port=htons(atoi(argv[1]));

	if(bind(serv_sd, (struct sockaddr*) &serv_addr, sizeof(serv_addr)) == -1)
		error_handling("bind() error");

	if(listen(serv_sd, 5) == -1)
		error_handling("listen() error");

	clnt_addr_size = sizeof(clnt_addr);
	
	clnt_sd = accept(serv_sd, (struct sockaddr*) &clnt_addr, &clnt_addr_size);
	if(clnt_sd == -1)
		error_handling("accept() error");
   
	close(serv_sd); //      
// ----------------------------------------------------------------------------
	//  ޴ κ
	// Ŭ̾Ʈ  ޽  get_file_from_client put_file_to_client 
	while(1)
	{
		strcpy(file_name, "./org2cmp/"); //  Ư  ʱȭ


// **********************************************************************************
// ̺κ  Ǵ° ϴ.
		memset(message_from_client, 0,   4);
		printf("hey : %s\n", message_from_client);
		recv(clnt_sd, message_from_client, 4, 0); // ɾ ޴´.
		printf("%s\n", message_from_client);
// **********************************************************************************
		
		if(strcmp(message_from_client, "put") == 0)
		{
			memset(only_file_name,      0,  14);
			recv(clnt_sd, only_file_name, FILENAMESIZE+1, 0);
			memset(file_name,           0, 256);
			strcat(file_name, only_file_name); // εڿ ̸ δ.
			get_file_from_client(file_name);
		}
		else if(strcmp(message_from_client, "get") == 0)
		{
			read(clnt_sd, file_name, FILENAMESIZE+8);
			put_file_to_client(file_name);
		}
		else if(strcmp(message_from_client, "end") == 0)
		{
			break;
		}
		else
		{
			error_handling("wrong message error");
		}
	
	}
// ----------------------------------------------------------------------------

	// Ŭ̾Ʈ  ϵ  ޴ κ	
	get_file_from_client("cmp2org.txt");

// ----------------------------------------------------------------------------	
	// Ŭ̾Ʈ   κ.
	//    ϵ Ŭ̾Ʈ Ư  ִ´.
	//  Ʈ  openѴ.
	fp = fopen("cmp2org.txt", "r");
	if(fp == NULL) {
		error_handling("File open error");
	}

	while(fscanf(fp, "%s", &file_name) != EOF)
	{
		// ɼ  ο ̸ cast_name 
		len = strlen(file_name);
		k = 0;
		for(i = 3 ; i <= len ; i++)
		{
			cast_name[k] = file_name[i];
			k++;
		}
		if(file_name[1] == 'X')
		{
			write(clnt_sd, "put", 4);
			//  ̸ θ  κ
			k = 0;
			for(i = len - FILENAMESIZE ; i <= len ; i++)
			{
				orig_name[k] = file_name[i];
				k++;
			}
			write(clnt_sd, orig_name, FILENAMESIZE+1);
			put_file_to_client(cast_name);
		}
		else if (file_name[1] == 'S')
		{
			printf("Different size ! 1 - put, 2 - get");
			scanf("%d", &select_file);
			if(select_file == 1)
			{
				write(clnt_sd, "put", 3);
				put_file_to_client(file_name);
			}
			else
			{
				get_file_from_client(file_name);
			}
		}
		else
		{
			error_handling("File name error");
		}

	}
	fclose(fp); //  κ  bind  .
	write(clnt_sd, "end", 4); //    


// ----------------------------------------------------------------------------	
	//  ݴ κ
	close(clnt_sd);
	return 0;

}

int put_file_to_client(char *file_name)
{
	int fd;
	int len;
	char buf[BUFSIZE];
	
	// Ŭ̾Ʈ   Ѵ.
	fd = open(file_name, O_RDONLY, 00400);
	if(fd == -1) {
		error_handling("File open error");
	}

	// ŬƮ  
	len = read(fd, buf, BUFSIZE);
	write(clnt_sd, buf, len);


	// Ϸ ޼ Ѵ.
	len = read(clnt_sd, buf, 20); 
	write(1, buf, len);

	close(fd);
	return 0;
}

int get_file_from_client(char *file_name)
{
	int fd;
	int len;
	char buf[BUFSIZE];
	
	//  ͸   
	fd = open(file_name, O_WRONLY | O_CREAT | O_TRUNC, 00644);
	if(fd == -1)
		error_handling("File open error");

	len = read(clnt_sd, buf, BUFSIZE);
	
	write(fd, buf, len);

	write(clnt_sd, "client : complete\n", 20);
	close(fd);
	return 0;
	
}


void error_handling(char *message)
{
	fputs(message, stderr);
	fputc('\n', stderr);  
	exit(1);
}
